# rm::composition::content::entry
# entry module
# http://www.openehr.org/uml/release-1.0.1/Browsable/_9_0_76d0249_1109264528523_312165_346Report.html
# refs #56
include OpenEHR::RM::Composition::Content

module OpenEHR
  module RM
    module Composition
      module Content
        module Entry
          class Entry < ContentItem
            attr_reader :language, :encoding, :subject
            attr_accessor :provider, :other_participations, :workflow_id
            def initialize(args = { })
              super(args)
              self.language = args[:language]
              self.encoding = args[:encoding]
              self.subject = args[:subject]
              self.provider = args[:provider]
              self.other_participations = args[:other_participations]
              self.workflow_id = args[:workflow_id]
            end

            def language=(language)
              raise ArgumentError, 'language is mandatory' if language.nil?
              @language = language
            end

            def encoding=(encoding)
              raise ArgumentError, 'encoding is mandatory' if encoding.nil?
              @encoding = encoding
            end

            def subject=(subject)
              raise ArgumentError, 'subject is mandatory' if subject.nil?
              @subject = subject
            end

            def subject_is_self?
              return @subject.instance_of? PartySelf
            end
          end
          
          class CareEntry < Entry
            
          end
          
          class Action < CareEntry
            attr_accessor :description, :time
            attr_accessor :ism_transition, :instruction_details
            
            def initialize(description, time, ism_transition, instruction_details)
              raise Exception.new("invalid argument") if description == nil || time == nil || ism_transition == nil
              @description = description
              @time = time
              @ism_transition = ism_transition
              @instruction_details = instruction_details if instruction_details != nil
            end
          end # of Action
        end # of Entry
      end # of Content
    end # of Composition
  end # of RM
end # of OpenEHR
